# Ex3.py
# Get number of recommendations for a selected movie

from operator import itemgetter

datRatings = "ratings.dat"
moviesInfo = "movies.csv"

def loadData(fileName):
    try:    
        fData = open(fileName, 'r')
    except:
        return []
    out = []
    for line in fData:
        line = line[:-1]  # remove \n
        if len(line) == 0:  # empty line
            continue
        li = [i for i in line.split(",")]
        out.append(li)
    fData.close()
    return out

samples = loadData(datRatings)
id = 0
X = [] 
li = []
for sample in samples:
    personId = int(sample[0])
    if personId != id:
        X.append(li)
        id = personId
        li = [sample[1]]
    else:
        li.append(sample[1])

def getMovieIds():
    movieIds = []
    for i in range(1,len(movies)):
        movieIds.append(int(movies[i][0]))
    return movieIds

def getMovieTitle(movieId):
    for movie in movies:
        try:
            if int(movie[0]) == movieId:
                return movie[1]
        except:
            continue
    return ""  

movies = loadData(moviesInfo)
ranking = []
nbMovies = 200 # take 200 first movies only
movieIds = getMovieIds()
for i in range(nbMovies):
    sum = 0
    movieId = movieIds[i]
    for sample in X:
        for id in sample:
            if int(id) == movieId:
                sum += 1
    ranking.append([movieId, sum])

ranking = sorted(ranking, key = itemgetter(1)) # sort records with decreasing number of recommendations
ranking = ranking[::-1] # reverse
# 10 top movies
for i in range(10):
    print "#", i + 1, ":", getMovieTitle(ranking[i][0]), "--->", ranking[i][1], "recommendations"
